/*
**++
**
**  MODULE DESCRIPTION:
**
**      Set FTA's TT_ACCPORNAM from SYS$REM_NODE logical name
**	workaround for HP's TCPIP 5.5-11 ECO1 ssh server
**
**  AUTHORS:
**
**      Maulis, Adam <maulis@ludens.elte.hu>
**
**  CREATION DATE:  13-mar-2006
**
**  COPYRIGHT: public domain
**   Absolutly no warranty
**
**--
*/


/*
**
**  INCLUDE FILES
**
*/

#include descrip
#include starlet
#include ssdef
#include psldef
#include lnmdef
#include dvidef

#include <stdio.h>
#include <string.h>

$DESCRIPTOR(termname,"TT");
$DESCRIPTOR(proctabname,"LNM$PROCESS_TABLE");
$DESCRIPTOR(sysremnode,"SYS$REM_NODE");
$DESCRIPTOR(jobtabname,"LNM$JOB");

#define dsNULLSTRING {0,DSC$K_DTYPE_T,DSC$K_CLASS_S,0}

int FTA_SET_ACCPORNAM ( int, int, char * );

struct item_list_3 {
    unsigned short it3$w_buflen;
    unsigned short it3$w_code;
    char *         it3$a_buffer;
    void *         it3$a_retlen;
};



int main()
{
    unsigned int status;
    unsigned char accmode = PSL$C_EXEC;
    unsigned short chann;
    char ttdevname[256];
    unsigned short ttdevname_len;
    struct dsc$descriptor ttdev = dsNULLSTRING;
    struct item_list_3 tt_getres [] =
    {
      { sizeof(ttdevname)-1, LNM$_STRING, ttdevname, &ttdevname_len },
      { 0,0,0,0 }
    };
    char accpornam[64];
    unsigned short accpornam_len;
    struct dsc$descriptor tt_accpornam = dsNULLSTRING;
    struct item_list_3 getaccpornam [] =
    {
      { sizeof(accpornam), DVI$_TT_ACCPORNAM, accpornam, &accpornam_len },
      { 0,0,0,0 }
    };
    char remnode[256];
    unsigned short remnode_len;
    struct item_list_3 remnode_getres [] =
    {
      { sizeof(remnode)-1, LNM$_STRING, remnode, &remnode_len },
      { 0,0,0,0 }
    };


    /*
    ** get terminal name (TT in LNM$PROCESS_TABLE, exec mode only)
    ** and looking for tt_accpornam
    */

    status = sys$trnlnm (
    	0, 
    	&proctabname, 
    	&termname,
    	&accmode,
    	&tt_getres);

    if( 1 != (status & 1)  ) return status;
    if( 0 == ttdevname_len ) return SS$_NORMAL;  /* no regular or error */
    /* printf("DEBUG: TT: \"%.*s\"\n",ttdevname_len, ttdevname); */
    if( 4 > ttdevname_len )  return SS$_NORMAL;  /* no fta (too short) */
    if( 0 != strncmp(ttdevname, "_FTA", 4) ) return SS$_NORMAL;   /* no fta */

    ttdev.dsc$a_pointer = ttdevname;
    ttdev.dsc$w_length  = ttdevname_len;

    status = sys$assign (&ttdev, &chann, 0, 0, 0);
    if( 1 != (status & 1)  ) return status;

    status = sys$getdviw (
    	0, 
    	chann,
    	0,
    	&getaccpornam, 
    	0, 0, 0, 0);
    if( 1 != (status & 1)  ) return status;
    /* printf("DEBUG: accpornam_len: %d\n", accpornam_len); */
    /* printf("DEBUG: tt_accpornam: \"%.*s\"\n",accpornam_len, accpornam); */
    if( 0 != accpornam_len ) return SS$_NORMAL; /* accpornam already set up */

    /*
    ** get SYS$REM_NODE (from lnm$job, exec mode)
    */


    status = sys$trnlnm (
    	0, 
    	&jobtabname, 
    	&sysremnode, 
    	&accmode, 
    	&remnode_getres);

    if( 1 != (status & 1)  ) return status;
    if( 0 == remnode_len ) return SS$_NORMAL;  /* no regular or error */
    /* printf("DEBUG: remnode: \"%.*s\"\n",remnode_len, remnode); */

    /*
    ** Manipulate remnode string
    */

    if( remnode[remnode_len-1] == ':' && remnode[remnode_len-2] == ':')
	remnode_len-=2;

    if( 64 < remnode_len ) remnode_len = 64; /* truncate */
    /* printf("DEBUG: remnode_len: %d\n", remnode_len); */
    /* printf("DEBUG: remnode: \"%.*s\"\n",remnode_len, remnode); */


    /*
    ** set TT_ACCPORNAM
    */

    status = FTA_SET_ACCPORNAM( chann, remnode_len, remnode );
    if( 1 != (status & 1)  ) return status;

    /* $dassign called by image rundown == dirty coding */
    return SS$_NORMAL;
}
